"use strict";

var bind = function bind(v, k) {
  return k(v);
},
    commaList = [","],
    isString = function isString(x) {
  return typeof(x) === "string";
},
    transformComma = function transformComma(_x, _x2, _x3, _x4) {
  var _again = true;

  _function: while (_again) {
    var acc = _x,
        buffer = _x2,
        tree = _x3,
        isLastInline = _x4;
    _again = false;
    undefined;

    if (tree.length === 0) {
      return buffer.length === 0 ? acc : acc.concat([commaList.concat(buffer)]);
    } else {
      if (acc.length === 0) {
        _x = acc.concat(tree.slice(0, 1));
        _x2 = buffer;
        _x3 = tree.slice(1);
        _x4 = true;
        _again = true;
        continue _function;
      } else {
        return bind(isString(tree[0]), function (isThisInline) {
          return (function () {
            switch (true) {
              case isLastInline && isThisInline:
                return buffer.length === 0 ? transformComma(acc.concat(tree.slice(0, 1)), [], tree.slice(1), true) : transformComma(acc, buffer.concat(tree.slice(0, 1)), tree.slice(1), true);

              case !isLastInline && isThisInline:
                return transformComma(acc, buffer.concat(tree.slice(0, 1)), tree.slice(1), true);

              case isLastInline && !isThisInline:
                return buffer.length === 0 ? transformComma(acc.concat(tree.slice(0, 1)), [], tree.slice(1), false) : transformComma(acc.concat([commaList.concat(buffer)], tree.slice(0, 1)), [], tree.slice(1), false);

              default:
                return transformComma(acc.concat(tree.slice(0, 1)), [], tree.slice(1), false);
            }
          })();
        });
      }
    }
  }
},
    insertComma = function insertComma(tree) {
  return tree.map(function (line) {
    return transformComma([], [], line, true);
  });
},
    transformDollar = function transformDollar(acc, tree, isLastInline, index) {
  return (function () {
    switch (tree.length) {
      case 0:
        return acc;

      case 1:
        return isLastInline ? index > 0 && Array.isArray(tree[0]) ? acc.concat("$", tree[0]) : acc.concat(tree) : acc.concat(tree);

      default:
        return transformDollar(acc.concat(bind(tree[0], function (cursor) {
          return Array.isArray(cursor) ? [transformDollar([], cursor, true, 0)] : tree.slice(0, 1);
        })), tree.slice(1), isString(tree[0]), index + 1);
    }
  })();
},
    insertDollar = function insertDollar(tree) {
  return tree.map(function (line) {
    return transformDollar([], line, true, 0);
  });
};

exports.insertComma = insertComma;
exports.insertDollar = insertDollar;